Super Jumping! Jumping! Jumping!||HDU1087

来源:互联网 发布:java多态的实现原理 编辑:程序博客网 时间:2024/06/06 03:02

Link:http://acm.hdu.edu.cn/showproblem.php?pid=1087
Problem Description

Nowadays, a kind of chess game called “Super Jumping! Jumping! Jumping!” is very popular in HDU. Maybe you are a good boy, and know little about this game, so I introduce it to you now.The game can be played by two or more than two players. It consists of a chessboard(棋盘)and some chessmen(棋子), and all chessmen are marked by a positive integer or “start” or “end”. The player starts from start-point and must jumps into end-point finally. In the course of jumping, the player will visit the chessmen in the path, but everyone must jumps from one chessman to another absolutely bigger (you can assume start-point is a minimum and end-point is a maximum.). And all players cannot go backwards. One jumping can go from a chessman to next, also can go across many chessmen, and even you can straightly get to end-point from start-point. Of course you get zero point in this situation. A player is a winner if and only if he can get a bigger score according to his jumping solution. Note that your score comes from the sum of value on the chessmen in you jumping path.Your task is to output the maximum value according to the given chessmen list.

Input

Input contains multiple test cases. Each test case is described in a line as follow:N value_1 value_2 …value_NIt is guarantied that N is not more than 1000 and all value_i are in the range of 32-int.A test case starting with 0 terminates the input and this test case is not to be processed.

Output

For each case, print the maximum according to rules, and one line one case.

Sample Input

3 1 3 24 1 2 3 44 3 3 2 10

Sample Output

4103

题解:最大递增子序列和
求最长上升子序列的最大和。第一层循环用于遍历每一个数,用i表示。然后第二层循环用于从头遍历到当前这个数i的前一个数,用j表示。如果a[i] > a[j],则说明以j结尾的最长上升子序列加上i以后依然能构成一个最长上升子序列,但这是依然需要继续向后遍历,因为这是求最长上升子序列的最大和(同一长度的最长上升子序列不唯一)。如果到索引j所形成的最长上升子序列的和大于目前为止的最长上升子序列的和ans,那么就更新ans的值。然后最后通过ans+a[i]便得到了到索引i所能形成的最长上升子序列的最大和。接下来就是更新一下到目前位置所能得到的全局的最长上升子序列的最大和。(上面所说的那个ans只是局部的最长上升子序列)。

#include<cstdio>#include<cstring>#include<cmath>#include<cstdlib>#include<iostream>#include<algorithm>using namespace std;int a[1005],dp[1005];int n;int LIS(){    int i,j,ans,s=-9999;    for(i=0;i<n;i++)    {        ans=0;        for(j=0;j<i;j++)        {            if(a[j]<a[i])                ans=max(ans,dp[j]);        }        dp[i]=ans+a[i];        s=max(s,dp[i]);    }    return s;}int main(){    int i;    while(scanf("%d",&n),n)    {        memset(dp,0,sizeof(dp));        for(i=0;i<n;i++)           scanf("%d",&a[i]);        printf("%d\n",LIS());    }return 0;}//3 1 3 2//4 1 2 3 4//4 3 3 2 1//0
原创粉丝点击